{
    "$graph": [
        {
            "class": "CommandLineTool",
            "id": "#generate_fscr_feats.cwl",
            "baseCommand": "generate_fscr_feats",
            "arguments": [
                "-nogenbank"
            ],
            "label": "generate_fscr_feats",
            "inputs": [
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-excluded-seqs"
                    },
                    "id": "#generate_fscr_feats.cwl/generate_fscr_feats/excluded_seqs"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-input"
                    },
                    "id": "#generate_fscr_feats.cwl/generate_fscr_feats/input"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "prefix": "-label-suffix"
                    },
                    "id": "#generate_fscr_feats.cwl/generate_fscr_feats/label_suffix"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "prefix": "-o"
                    },
                    "id": "#generate_fscr_feats.cwl/generate_fscr_feats/o"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "prefix": "-source"
                    },
                    "id": "#generate_fscr_feats.cwl/generate_fscr_feats/source"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.o)"
                    },
                    "id": "#generate_fscr_feats.cwl/generate_fscr_feats/feats"
                }
            ]
        },
        {
            "label": "gpx_qdump",
            "class": "CommandLineTool",
            "baseCommand": "gpx_qdump",
            "inputs": [
                {
                    "type": "Directory",
                    "inputBinding": {
                        "prefix": "-input-path"
                    },
                    "id": "#gpx_qdump.cwl/input_path"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "output.asn",
                    "inputBinding": {
                        "prefix": "-output"
                    },
                    "id": "#gpx_qdump.cwl/output_name"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-unzip"
                    },
                    "id": "#gpx_qdump.cwl/unzip"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_name)"
                    },
                    "id": "#gpx_qdump.cwl/output"
                }
            ],
            "id": "#gpx_qdump.cwl"
        },
        {
            "label": "gpx_qsubmit",
            "doc": "This workflow is specialized for the case when there is an LDS2 input  LDS2 is a _reference_ object, the kind that CWL does not like we need to provide actual input: proteins which matches the name of ASN.1 object references in LDS2 Another limitation is that it can handle no more than two item arrays in blastdb_dir and asn_cache Workaround used so far: in:\n  proteins:\n    default:\n        class: File\n        path: '/dev/null'\n        basename: 'null'\n        contents: ''\n",
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entry": "$(inputs.proteins)",
                            "writable": false
                        },
                        {
                            "entry": "${ var cs=0; var s=inputs.blastdb_dir.length-1; var as = cs; if(as >= s) {as = s }; return inputs.blastdb_dir[as]; }",
                            "writable": false
                        },
                        {
                            "entry": "${ var cs=1; var s=inputs.blastdb_dir.length-1; var as = cs; if(as >= s) {as = s }; return inputs.blastdb_dir[as]; }",
                            "writable": false
                        },
                        {
                            "entry": "${ var cs=0; var s=inputs.asn_cache.length-1; var as = cs; if(as >= s) {as = s }; return inputs.asn_cache[as]; }",
                            "writable": false
                        },
                        {
                            "entry": "${ var cs=1; var s=inputs.asn_cache.length-1; var as = cs; if(as >= s) {as = s }; return inputs.asn_cache[as]; }",
                            "writable": false
                        },
                        {
                            "entryname": "ids.mft",
                            "entry": "${var blob = '# ids.mft created for gpx_qsubmit from input ids Array of Files\\n';for (var i = 0; i < inputs.ids.length; i++) {blob += inputs.ids[i].path  + '\\n';}return blob;}"
                        }
                    ]
                }
            ],
            "baseCommand": "gpx_qsubmit",
            "inputs": [
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-NxM-threshold"
                    },
                    "id": "#gpx_qsubmit.cwl/NxM_threshold"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "subject",
                    "inputBinding": {
                        "prefix": "-affinity"
                    },
                    "id": "#gpx_qsubmit.cwl/affinity"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "Directory"
                        }
                    ],
                    "inputBinding": {
                        "prefix": "-asn-cache",
                        "itemSeparator": ","
                    },
                    "id": "#gpx_qsubmit.cwl/asn_cache"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-batch-size"
                    },
                    "id": "#gpx_qsubmit.cwl/batch_size"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "inputBinding": {
                        "prefix": "-db",
                        "valueFrom": "${ var blob = ''; for (var i = 0; i < inputs.blastdb_dir.length; i++) { blob += inputs.blastdb_dir[i].path + '/' + inputs.blastdb[i]; if(i != inputs.blastdb_dir.length-1) blob += ','; } return blob; }"
                    },
                    "id": "#gpx_qsubmit.cwl/blastdb"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "Directory"
                        }
                    ],
                    "id": "#gpx_qsubmit.cwl/blastdb_dir"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "File"
                        }
                    ],
                    "id": "#gpx_qsubmit.cwl/ids"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "ids.mft",
                    "inputBinding": {
                        "prefix": "-ids-manifest"
                    },
                    "id": "#gpx_qsubmit.cwl/ids_manifest"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-lds2"
                    },
                    "id": "#gpx_qsubmit.cwl/lds2"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-max-batch-length"
                    },
                    "id": "#gpx_qsubmit.cwl/max_batch_length"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": true,
                    "inputBinding": {
                        "prefix": "-nogenbank"
                    },
                    "id": "#gpx_qsubmit.cwl/nogenbank"
                },
                {
                    "type": "string",
                    "default": "jobs.xml",
                    "inputBinding": {
                        "prefix": "-o"
                    },
                    "id": "#gpx_qsubmit.cwl/output_xml_jobs"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-overlap"
                    },
                    "id": "#gpx_qsubmit.cwl/overlap"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#gpx_qsubmit.cwl/proteins"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-queries-gc-id-list"
                    },
                    "id": "#gpx_qsubmit.cwl/queries_gc_id_list"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-subjects-gc-id-list"
                    },
                    "id": "#gpx_qsubmit.cwl/subjects_gc_id_list"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-subseq-size"
                    },
                    "id": "#gpx_qsubmit.cwl/subseq_size"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-xml-jobs"
                    },
                    "id": "#gpx_qsubmit.cwl/xml_jobs"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_xml_jobs)"
                    },
                    "id": "#gpx_qsubmit.cwl/jobs"
                }
            ],
            "id": "#gpx_qsubmit.cwl"
        },
        {
            "class": "CommandLineTool",
            "id": "#univec_wnode.cwl",
            "baseCommand": "univec_wnode",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entry": "$(inputs.blastdb_dir)",
                            "writable": false
                        },
                        {
                            "entry": "$(inputs.asn_cache)",
                            "writable": false
                        }
                    ]
                }
            ],
            "arguments": [
                "-nogenbank"
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "output",
                    "doc": "Base path to files of output generated from processes",
                    "inputBinding": {
                        "position": 0,
                        "prefix": "-O"
                    },
                    "id": "#univec_wnode.cwl/univec_wnode/O"
                },
                {
                    "type": "Directory",
                    "inputBinding": {
                        "prefix": "-asn-cache"
                    },
                    "id": "#univec_wnode.cwl/univec_wnode/asn_cache"
                },
                {
                    "type": "Directory",
                    "doc": "Hidden parameter, hidden within input_jobs:",
                    "id": "#univec_wnode.cwl/univec_wnode/blastdb_dir"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "-input-jobs"
                    },
                    "label": "input_jobs",
                    "doc": "XML file with input univec jobs, this parameter is _referential_ which CWL does not like.\n",
                    "id": "#univec_wnode.cwl/univec_wnode/input_jobs"
                }
            ],
            "outputs": [
                {
                    "type": "Directory",
                    "outputBinding": {
                        "glob": "$(inputs.O)"
                    },
                    "id": "#univec_wnode.cwl/univec_wnode/outdir"
                }
            ],
            "label": "univec_wnode"
        },
        {
            "class": "Workflow",
            "id": "#main",
            "doc": "univ_wnode",
            "label": "univec_wnode",
            "requirements": [
                {
                    "class": "MultipleInputFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "Directory",
                    "id": "#main/asn_cache"
                },
                {
                    "type": "string",
                    "id": "#main/blastdb"
                },
                {
                    "type": "Directory",
                    "id": "#main/blastdb_dir"
                },
                {
                    "type": "File",
                    "id": "#main/gilist"
                }
            ],
            "steps": [
                {
                    "run": "#generate_fscr_feats.cwl",
                    "label": "generate_fscr_feats",
                    "in": [
                        {
                            "source": "#main/gpx_qdump/output",
                            "id": "#main/generate_fscr_feats/input"
                        },
                        {
                            "default": "Adaptor",
                            "id": "#main/generate_fscr_feats/label_suffix"
                        },
                        {
                            "default": "fscr_feats.asn",
                            "id": "#main/generate_fscr_feats/o"
                        },
                        {
                            "default": "vector",
                            "id": "#main/generate_fscr_feats/source"
                        }
                    ],
                    "out": [
                        "#main/generate_fscr_feats/feats"
                    ],
                    "id": "#main/generate_fscr_feats"
                },
                {
                    "run": "#gpx_qdump.cwl",
                    "label": "gpx_qdump",
                    "in": [
                        {
                            "source": "#main/univec_wnode/outdir",
                            "id": "#main/gpx_qdump/input_path"
                        },
                        {
                            "default": "*",
                            "id": "#main/gpx_qdump/unzip"
                        }
                    ],
                    "out": [
                        "#main/gpx_qdump/output"
                    ],
                    "id": "#main/gpx_qdump"
                },
                {
                    "run": "#gpx_qsubmit.cwl",
                    "label": "gpx_qsubmit",
                    "in": [
                        {
                            "source": [
                                "#main/asn_cache"
                            ],
                            "linkMerge": "merge_flattened",
                            "id": "#main/gpx_qsubmit/asn_cache"
                        },
                        {
                            "source": [
                                "#main/blastdb"
                            ],
                            "linkMerge": "merge_flattened",
                            "id": "#main/gpx_qsubmit/blastdb"
                        },
                        {
                            "source": [
                                "#main/blastdb_dir"
                            ],
                            "linkMerge": "merge_flattened",
                            "id": "#main/gpx_qsubmit/blastdb_dir"
                        },
                        {
                            "source": [
                                "#main/gilist"
                            ],
                            "linkMerge": "merge_flattened",
                            "id": "#main/gpx_qsubmit/ids"
                        },
                        {
                            "default": {
                                "class": "File",
                                "path": "https://raw.githubusercontent.com/dev/null",
                                "basename": "null",
                                "contents": ""
                            },
                            "id": "#main/gpx_qsubmit/proteins"
                        }
                    ],
                    "out": [
                        "#main/gpx_qsubmit/jobs"
                    ],
                    "id": "#main/gpx_qsubmit"
                },
                {
                    "run": "#univec_wnode.cwl",
                    "label": "univec_wnode",
                    "in": [
                        {
                            "source": "#main/asn_cache",
                            "id": "#main/univec_wnode/asn_cache"
                        },
                        {
                            "source": "#main/blastdb_dir",
                            "id": "#main/univec_wnode/blastdb_dir"
                        },
                        {
                            "source": "#main/gpx_qsubmit/jobs",
                            "id": "#main/univec_wnode/input_jobs"
                        }
                    ],
                    "out": [
                        "#main/univec_wnode/outdir"
                    ],
                    "id": "#main/univec_wnode"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#main/generate_fscr_feats/feats",
                    "id": "#main/feats"
                },
                {
                    "type": "File",
                    "outputSource": "#main/gpx_qdump/output",
                    "id": "#main/hits"
                }
            ]
        }
    ],
    "cwlVersion": "v1.0"
}
